/*************************************************************************
 *
 *    Used with ARM IAR C/C++ Compiler.
 *
 *    (c) Copyright IAR Systems 2007
 *
 *    File name      : usb_buffer.h
 *    Description    : usb_buffer manager module include file
 *
 *    History :
 *    1. Date        : June 23, 2007
 *       Author      : Stanimir Bonev
 *       Description : Create
 *
 *    $Revision: $
 **************************************************************************/
#include "arm_comm.h"
#include "usb_cnfg.h"
#include "usb_hw.h"

#ifndef __USB_BUFFER_H
#define __USB_BUFFER_H

#ifdef BUFFER_GLOBAL
#define BUFFER_EXTERN
#else
#define BUFFER_EXTERN extern
#endif

#define BUFF_MSG_FILE stdout

#if BUFF_TRACE_M_EN != 0
#define  BUFF_TRACE_M_INFO(...)   fprintf(BUFF_MSG_FILE,  __VA_ARGS__)
#else
#define  BUFF_TRACE_M_INFO(...)
#endif

#if BUFF_TRACE_WM_EN != 0
#define  BUFF_TRACE_WM_INFO(...)  fprintf(BUFF_MSG_FILE,  __VA_ARGS__)
#else
#define  BUFF_TRACE_WM_INFO(...)
#endif

#if BUFF_TRACE_EM_EN != 0
#define  BUFF_TRACE_EM_INFO(...)  fprintf(BUFF_MSG_FILE,  __VA_ARGS__)
#else
#define  BUFF_TRACE_EM_INFO(...)
#endif

/*************************************************************************
 * Function Name: USB_IO_Data
 * Parameters: USB_Endpoint_t EP, pInt8U pBuffer, Int32U Size, void * pFn
 * Return: none
 * Description: Prepare and send
 *
 *************************************************************************/
void USB_IO_Data (USB_Endpoint_t EP, pInt8U pBuffer, Int32U Size, void * pFn);

#endif // __USB_BUFFER_H

